program exercise12
  implicit none

  integer :: n

  do n = 1, 30

     print *, "n = ", n, " n! = ", factorial(n)  ! 下で定義された関数factorialを使って階乗を計算

  end do

  ! メインのプログラムはここまで
  
contains ! このプログラムexercise12に含まれている内部副プログラム
  
  function factorial(n)  !関数副プログラムfactorial、引数はn
    integer, intent(in) :: n      ! 引数nは整数型でintent(in)属性をつける(関数内で値を変更できない)
    integer :: k
    double precision :: factorial ! 関数の戻り値は関数と同名の変数で倍精度実数型とした

    !階乗ではn>=0でしか計算できないので負の数が入力されたときのエラー処理
    factorial = 0.0d0   
    if(n < 0) return  ! n<0であればこの時点でのfactorial(ゼロ)を返す(関数副プログラムを終了)

    factorial = 1.0d0   ! 初期値1をセット
    if(n == 0) return ! n=0の場合は 0! = 1 なので1を返して関数副プログラムを終了

    ! ここまで来る処理はnが正の場合

    ! 通常の方法で階乗を倍精度実数として計算
    do k = 1, n ! このdoループはn=0の場合は期待通りの振る舞いをしないため手前で例外的に処理をした
       factorial = factorial * dble(k) 
    end do

    return  ! n>0の場合はdoループで計算されたfactorialの値を返す
    
  end function factorial
    
end program exercise12
